package com.huimv.production.datasource.service.impl;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.huimv.production.datasource.dao.repo.TDeliveryRepo;
import com.huimv.production.datasource.service.IErpDataService;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;

/**
 * @Project : huimv.shiwan
 * @Package : com.huimv.biosafety.uface.controller
 * @Description : TODO
 * @Version : 1.0
 * @Author : ZhuoNing
 * @Create : 2020-12-25
 **/
@Service
@Slf4j
public class ErpDataServiceImpl implements IErpDataService {

    @Autowired
    private TDeliveryRepo tDeliveryRepo;

    /**
     * @Method      : getPsy
     * @Description : Psy
     * @Params      : []
     * @Return      : java.lang.String
     * 
     * @Author      : ZhuoNing
     * @Date        : 2021/5/15       
     * @Time        : 11:40
     */
    @Override
    public String getPsy() {
        List<Object[]> psyFieldList = tDeliveryRepo.getPsy();
//        System.out.println("psyFieldList.size: "+psyFieldList.size());
        String psy = "";
        for (Object[] goodsObj : psyFieldList) {
//            System.out.println("0:"+goodsObj[0]);
            psy = goodsObj[0].toString();
        }
        return psy;
    }

    /**
     * @Method      : getReEstrusRate
     * @Description : 返情率
     * @Params      : []
     * @Return      : java.lang.String
     * 
     * @Author      : ZhuoNing
     * @Date        : 2021/5/15       
     * @Time        : 11:41
     */
    @Override
    public String getReEstrusRate(String startDate,String endDate) {
        log.info(" 开始日期（返情率） startDate:"+startDate);
        log.info(" 结束日期（返情率） endDate:"+endDate);
        List<Object[]> reEstrusRateFieldList = tDeliveryRepo.getReEstrusRate(startDate,endDate);
        log.info(" 返情率查询数量:"+reEstrusRateFieldList.size());
        JSONArray resultJa = new JSONArray();
        for (Object[] fieldObj : reEstrusRateFieldList) {
            String farmVal = fieldObj[0].toString();
            String varietyVal = fieldObj[1].toString();
            String reEstrusRateVal = fieldObj[2].toString();
            JSONObject dataJo = new JSONObject();
            dataJo.put("farm",farmVal);
            dataJo.put("variety",varietyVal);
            dataJo.put("reestrus_rate",reEstrusRateVal);
            resultJa.add(dataJo);
        }
        return resultJa.toJSONString();
    }

    /**
     * @Method      : getParturitionRate
     * @Description : 分娩率
     * @Params      : []
     * @Return      : java.lang.String
     * 
     * @Author      : ZhuoNing
     * @Date        : 2021/5/15       
     * @Time        : 11:41
     */
    @Override
    public String getParturitionRate(String startDate,String endDate) {
        log.info(" 开始日期（分娩率） startDate:"+startDate);
        log.info(" 结束日期（分娩率） endDate:"+endDate);
        List<Object[]> reEstrusRateFieldList = tDeliveryRepo.getParturitionRate(startDate,endDate);
        log.info(" 分娩率查询数量:"+reEstrusRateFieldList.size());
        JSONArray resultJa = new JSONArray();
        for (Object[] fieldObj : reEstrusRateFieldList) {
            String farmVal = fieldObj[0].toString();
            String varietyVal = fieldObj[1].toString();
            String reEstrusRateVal = fieldObj[2].toString();
            JSONObject dataJo = new JSONObject();
            dataJo.put("farm",farmVal);
            dataJo.put("variety",varietyVal);
            dataJo.put("parturition_rate",reEstrusRateVal);
            resultJa.add(dataJo);
        }
        return resultJa.toJSONString();
    }

    /**
     * @Method      : getStorage
     * @Description : 各种存栏
     * @Params      : []
     * @Return      : java.lang.String
     * 
     * @Author      : ZhuoNing
     * @Date        : 2021/5/15       
     * @Time        : 11:42
     */
    @Override
    public String getStorage() {
        return null;
    }

    /**
     * @Method      : getPigletInfo
     * @Description : 均产仔数，仔猪存活率
     * @Params      : []
     * @Return      : java.lang.String
     * 
     * @Author      : ZhuoNing
     * @Date        : 2021/5/15       
     * @Time        : 11:43
     */
    @Override
    public String getPigletInfo() {
        return null;
    }

    /**
     * @Method      : getMateQuantity
     * @Description : 配种数量
     * @Params      : []
     * @Return      : java.lang.String
     * 
     * @Author      : ZhuoNing
     * @Date        : 2021/5/15       
     * @Time        : 11:44
     */
    @Override
    public String getMateQuantity() {
        return null;
    }

    /**
     * @Method      : getConceptionRate
     * @Description : 受胎率
     * @Params      : []
     * @Return      : java.lang.String
     * 
     * @Author      : ZhuoNing
     * @Date        : 2021/5/15       
     * @Time        : 11:45
     */
    @Override
    public String getConceptionRate() {
        return null;
    }

    /**
     * @Method      : getAllStorage
     * @Description : 总存栏，母猪存栏
     * @Params      : []
     * @Return      : java.lang.String
     * 
     * @Author      : ZhuoNing
     * @Date        : 2021/5/15       
     * @Time        : 11:45
     */
    @Override
    public String getAllStorage() {
        return null;
    }
}
